<%Option Explicit
Response.CacheControl = "no-cache"
Response.AddHeader "Pragma", "no-cache"
Response.Expires = -1
%>
<HTML>
<HEAD>
<!--

                       LICENSE AND DISCLAIMER

 This material contains IBM copyrighted sample programming source
 code for your consideration.  This sample code has not been
 thoroughly tested under all conditions.  IBM, therefore, cannot
 guarantee or imply reliability, serviceability, or function.
 IBM provides no program services for this material. This material
 is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR
 IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  SOME
 JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED WARRANTIES, SO
 THE ABOVE EXCLUSIONS MAY NOT APPLY TO YOU.  IN NO EVENT WILL IBM
 BE LIABLE TO ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR OTHER
 CONSEQUENTIAL DAMAGES FOR ANY USE OF THIS MATERIAL INCLUDING,
 WITHOUT LIMITATION, ANY LOST PROFITS, BUSINESS INTERRUPTION, LOSS
 OF PROGRAMS OR OTHER DATA ON YOUR INFORMATION HANDLING SYSTEM OR
 OTHERWISE, EVEN IF EXPRESSLY ADVISED OF THE POSSIBILITY OF SUCH
 DAMAGES.


                          COPYRIGHT
                          ---------
               (C) Copyright IBM CORP. 1999, 2000
               All rights reserved.
               US Government Users Restricted Rights -
               Use, duplication or disclosure restricted
               by GSA ADP Schedule Contract with IBM Corp.
               Licensed Material - Property of IBM

-->
<!-- METADATA TYPE="typelib" UUID="AD8D8CE0-15D3-11D2-849C-0004AC94E175" NAME="IBM AS/400 Client Access Express ActiveX Object Library" -->
<TITLE>Version Active Server Page Sample</TITLE>
</HEAD>
<body bgcolor="#FFFFFF">
<h2>DSN Configuration Tool</h2>
<p>This form allows you to add or edit certain ODBC datasource 
keywords that are not available in the ODBC administrator setup program.  It operates on the current
DSN. Set or change the DSN name by using the <a href="default.asp">main form.</a>&nbsp; </p>

<p>This form will also try to retrieve the settings for the AS/400 system object
used by the datasource.&nbsp; You must first create a system object by either
successfully connecting to the AS/400 system using IIS or by running the cwbcfg
program with the&nbsp; /s option.&nbsp; Once the key is created you may want to
consider setting &quot;Port Lookup Mode&quot; to Standard (the value
&quot;2&quot;) and &quot;IP address lookup Mode&quot; to never (the value
&quot;4&quot;).&nbsp; This instructs Client Access to use the default port
numbers for Client Access Host Servers and to use the stored IP address for the
AS/400.&nbsp; It avoids the performance overhead of making these calls each time
a connection is made.&nbsp;&nbsp; </p>

<p>
<b>Note: </b>With the default configuration for windows 2000 and IIS 5, the IIS
profile does not have write authority to these registry keys.&nbsp; You must manually
edit the registry or use regedt32 to grant the IIS user write authority to the
ODBC datasource and Client Access system information keys. These keys are
located at&nbsp; <font SIZE="1" COLOR="#800000">&quot;HKEY_LOCAL_MACHINE\Software\ODBC\ODBC.INI\&lt;datasource
name&gt;&quot; </font>and <font SIZE="1" COLOR="#800000">&quot;HKEY_USERS\.DEFAULT\Software\IBM\Client
Access Express\CurrentVersion\Environments\My AS/400 Connections\&lt;system
name&gt;&quot;.</font> </p>

<%
On Error Resume Next
Dim CAVer			'Client Access Version in the form "vrm"
Dim WSH
Dim RegVal	
'DSN Properties
Dim SQLConnectPromptMode
Dim QueryTimeout
Dim DSNSystem
Dim cwbSystem
Dim IPAddrLookup
Dim PortLookup

'Verify WSH is installed.
Set WSH = CreateObject("Wscript.Shell")
if Err.Number <> 0 then		'Windows scripting host is optional on NT 4, included with 2000.
	response.write "Windows scripting host (WSH) is not installed. WSH for NT 4 can be downloaded from the Microsoft Web site.  " & _
						"Windows 2000 already includes WSH.  <br>"
	Response.Write("Error Number: <b>" & err.Number & " [0x" & Hex(err.NumBer) & "]</b><br>")
	Response.Write("Err.Description: <b>" & err.Description & "</b><br>")
	Response.Write("Err.Source: <b>" & err.Source & "</b><br>")
	Response.End			'Exit
end if

'Check if the DSN is an existing System DSN
RegVal = wsh.RegRead("HKLM\Software\ODBC\ODBC.INI\" & Trim(Session("ODBC_DataSourceName")) & "\System")
if Err.Number <> 0 then
	response.write "The Datasource <font color=#ff0020><b>" & Trim(Session("ODBC_DataSourceName")) & "</b></font> " & _
					" is not a valid System data source or IIS is no longer " & _
					" authorized to that part of the registry.  Use the <a href=""default.asp"">main form</a> " & _
					"to update the DSN name.  Use the ODBC administrator, located in the windows control panel, " & _
					"to create a new DSN.<br>"
	response.end 		'Exit
end if

'Get the Client Access version to see if the property is supported.
dim ca400			
Err.Clear
set ca400 = server.createobject("cwbx.ClientInfo")
CAVer = (ca400.ClientVersion * 100) + (ca400.ClientRelease * 10)			'Save off a numeric version number

'Check if the system hive is set up.  We don't want to create the hive for the system unless it already exists.
IPAddrLookup = -1					
PortLookup = -1					
Err.Clear
DSNSystem = wsh.RegRead("HKLM\Software\ODBC\ODBC.INI\" & Trim(Session("ODBC_DataSourceName")) & "\System")
if Err.Number = 0 and Len(DSNSystem) > 0 then
	IPAddrLookup = wsh.RegRead("HKEY_USERS\.DEFAULT\Software\IBM\Client Access Express\CurrentVersion\Environments\My AS/400 Connections\" & _
					Trim(DSNSystem) & "\Communication\IP address lookup mode")
	if Err.Number <> 0 then
		IPAddrLookup = -1					
		response.write PrintSysKeyError( DSNSystem )
	end if
	Err.Clear
	'response.write "ipaddrlookup: " & ipAddrlookup	& "<br>"					'dxd
	'response.write "Portlookup: " & Portlookup & "<br>"							'dxd
end if

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Process the form if we got here on a submit
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim FormErr
FormErr = FALSE
'Response.Write "Formdata chkQueryTimeoutDisabled = " & Request.Form("chkQueryTimeoutDisabled") & "<br>" 'dxd
'Response.Write "Formdata chkSQLConnectPromptModeDisabled = " & Request.Form("chkSQLConnectPromptModeDisabled") & "<br>" 'dxd
'Response.Write "Formdata submitted = " & Request.Form("submitted") & "<br>" 'dxd
If Request.Form.Count > 0 then
	If Request.Form("chkQueryTimeoutDisabled") = "CHECKED" then
		Err.Clear
		wsh.RegWrite "HKLM\Software\ODBC\ODBC.INI\" & Trim(Session("ODBC_DataSourceName")) & "\QueryTimeout", _
						"0", "REG_SZ"		'0 = Disable query timeout
		if Err.Number <> 0 then	FormErr = True		
	else
		'Enable
		Err.Clear
		wsh.RegWrite "HKLM\Software\ODBC\ODBC.INI\" & Trim(Session("ODBC_DataSourceName")) & "\QueryTimeout", _
						"1", "REG_SZ"		'1 (default) - Query timeout enabled.
		if Err.Number <> 0 then	FormErr = True			
	end if
	If Request.Form("chkSQLConnectPromptModeDisabled") = "CHECKED" then
		Err.Clear
		wsh.RegWrite "HKLM\Software\ODBC\ODBC.INI\" & Trim(Session("ODBC_DataSourceName")) & "\SQLConnectPromptMode", _
							"1", "REG_SZ"		'1 = Do not prompt on SQLConnect
		if Err.Number <> 0 then	FormErr = True		
	else
		Err.Clear
		wsh.RegWrite "HKLM\Software\ODBC\ODBC.INI\" & Trim(Session("ODBC_DataSourceName")) & "\SQLConnectPromptMode", _
						"0", "REG_SZ"		'0 = Prompt on SQLConnect if needed
		if Err.Number <> 0 then	FormErr = True		
	end if		

	'		The reg hive must be created via cwbcfg /s or a successful logon in versions (with write auth to the reg hive)
	If IPAddrLookup = -1 then	'Key does not exist
		FormErr = True
	else
		Err.Clear
		wsh.RegWrite "HKEY_USERS\.DEFAULT\Software\IBM\Client Access Express\CurrentVersion\Environments\My AS/400 Connections\" & _
					Trim(DSNSystem) & "\Communication\IP address lookup mode", _
							Request.Form("IPAddrLookup"), "REG_SZ"	
		if Err.Number <> 0 then	FormErr = True		
		Err.Clear
		wsh.RegWrite "HKEY_USERS\.DEFAULT\Software\IBM\Client Access Express\CurrentVersion\Environments\My AS/400 Connections\" & _
					Trim(DSNSystem) & "\Communication\Port lookup mode", _
							Request.Form("Portlookup"), "REG_SZ"	
		if Err.Number <> 0 then	FormErr = True		
	end if	
	If Not FormErr then
		response.write "<b>Changes saved. </b> <br>"
	else 
		response.write "<b>An error occurred saving one or more options. </b> The error is " & Err.Description & ".<br>"
	end if
end if

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Get the current values of the DSN (after form processing)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Err.Clear
SQLConnectPromptMode = wsh.RegRead("HKLM\Software\ODBC\ODBC.INI\" & Trim(Session("ODBC_DataSourceName")) & "\SQLConnectPromptMode")
if Err.Number <> 0 then
	SQLConnectPromptMode = "0"		'Prompt as needed.  Default if it does not exist
end if
Err.Clear
QueryTimeout = wsh.RegRead("HKLM\Software\ODBC\ODBC.INI\" & Trim(Session("ODBC_DataSourceName")) & "\QueryTimeout")
if Err.Number <> 0 then
	QueryTimeout = "1"		'Enabled.  Default if it does not exist
end if
Err.Clear
DSNSystem = wsh.RegRead("HKLM\Software\ODBC\ODBC.INI\" & Trim(Session("ODBC_DataSourceName")) & "\System")
if Err.Number <> 0 then
	DSNSystem = ""		
else
	'Get ip address lookup and port lookup values
	IPAddrLookup = wsh.RegRead("HKEY_USERS\.DEFAULT\Software\IBM\Client Access Express\CurrentVersion\Environments\My AS/400 Connections\" & _
					Trim(DSNSystem) & "\Communication\IP address lookup mode")
	if Err.Number <> 0 then IPAddrLookup = -1					
	Err.Clear
	PortLookup = wsh.RegRead("HKEY_USERS\.DEFAULT\Software\IBM\Client Access Express\CurrentVersion\Environments\My AS/400 Connections\" & _
					Trim(DSNSystem) & "\Communication\Port lookup mode")
	if Err.Number <> 0 then PortLookup = -1					
	Err.Clear					
	'response.write "After save, ipaddrlookup: " & ipAddrlookup	& "<br>"	'dxd
	'response.write "After save, Portlookup: " & Portlookup & "<br>"		'dxd
end if


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Write out the form
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Response.write "<form action=""DSNOption.asp"" METHOD=POST>"
Response.write "<table border=""0"" width=""100%"">"
Response.write "    <tr>"
Response.write "        <td width=""100%"">Current DSN: <b> " & Trim(Session("ODBC_DataSourceName")) & "</b> </td>"
Response.write "    </tr>"

'SQLConnectPromptMode row
Response.write "    <tr>"
'TODO:  Check for service pack number after one is assigned. 'ChkCASP(ca400.ClientVersion, ca400.ClientRelease, ca400.ClientFixLevel)
If CAVer >= 450 then		'dxd
	if SQLConnectPromptMode = 1 then
		Response.write "        <td width=""100%""><input type=""checkbox"" name=""chkSQLConnectPromptModeDisabled"" value=""CHECKED"" checked>" & _
						"Never prompt on SQLConnect API (" & SQLConnectPromptMode & "). R450 and later only.&nbsp; Recommended value is ""checked"". </td>"
	else
		Response.write "        <td width=""100%""><input type=""checkbox"" name=""chkSQLConnectPromptModeDisabled"" value=""CHECKED"">" & _
						"Never prompt on SQLConnect API (" & SQLConnectPromptMode & "). R450 and later only.&nbsp; Recommended value is ""checked"". </td>"
	end if
	Resonse.write 	
else
	Response.write "  <td width=""100%"">SQLConnectPromptMode is only supported at R450 and later.</td>"
end if
Response.write "      </tr>"

'Query Timeout Row
Response.write "    <tr>"
if QueryTimeout = 0 then	'0 disables
	Response.write "        <td width=""100%""><input type=""checkbox"" name=""chkQueryTimeoutDisabled"" value=""CHECKED"" checked>Disable Query Timeout " & _
						"(" & QueryTimeout & ")</td>"
else
	Response.write "        <td width=""100%""><input type=""checkbox"" name=""chkQueryTimeoutDisabled"" value=""CHECKED"">Disable Query Timeout " & _
							"(" & QueryTimeout & ")</td>"
end if
Response.write "    </tr>"

'IP address lookup
Response.write "    <tr>"
Response.write GetIPControlText(ipAddrLookup)
Response.write "    </tr>"

'Port lookup
Response.write "    <tr>"
Response.write GetPortControlText(Portlookup)
Response.write "    </tr>"

Response.write "    <tr>"
Response.write "        <td align=""center"" width=""100%""><input type = ""SUBMIT"" value=""SUBMIT""> </td>"
Response.write "    </tr>"

Response.write "</table>"
'dxd Response.write "<INPUT TYPE=""Hidden"" NAME=""submitted"" value=""submitted"">"	'Detect if this is a submit w/o checked data or first call
Response.write "</form>"

Set WSH = Nothing
Set ca400 = Nothing
Response.End

'**************************************************************************************
'***   Subroutine to check CA service pack level
'**************************************************************************************
Function ChkCASP(V, R, ptf)		
	ChkCASP = FALSE		'Assuming it fails the check	
	'Check for Service Pack "none"
	if (Not IsNumeric(V) or Not IsNumeric(R) or Not IsNumeric( Mid(ptf, 3) )  ) then
		Exit Function		
	end if
		
	if (V = 4 and R = 4) then			'V4R4M0
		if Mid(ptf, 3) >= 63638 then   'SF63638 or later
			ChkCASP = TRUE
		end if
	elseif (V = 4 and R = 5) then 		'V4R5M0
		if Mid(ptf, 3) >= 62213 then	'All service packs
			ChkCASP = TRUE
		end if
	else
		'Assume all future releases require only the first service pack.
		ChkCASP = TRUE
	end if	
End Function

'********************************************************************************
' Set the default value to the current value
'********************************************************************************
Function GetIPControlText (defaultVal)
Dim S 
	
	if defaultVal < 0 or defaultVal > 5 then
		GetIPControlText = "<td width=""100%""><font color=#ff0020><b>Unable to retrieve IP address lookup mode.</b></font></td>"
		Exit function
	end if
	
	S =      "<td width=""100%""><select size=""1"" name=""IPAddrLookup"">" 
	if defaultVal = 0 then
		S = S &  "<option value=""0"" selected>cwbcoIPAddrLookupAlways (default)</option> " 
	else 
		S = S &  "<option value=""0"">cwbcoIPAddrLookupAlways (default)</option> " 
	end if 
	
	if defaultVal = 1 then
		S = S &  "<option value=""1"" selected>cwbcoIPAddrLookup1Hour</option>  "
	else
		S = S &  "<option value=""1"">cwbcoIPAddrLookup1Hour</option>  "
	end if 
	
	if defaultVal = 2 then
		S = S &  "<option value=""2"" selected>cwbcoIPAddrLookup1Day</option>  " 
	else
		S = S &  "<option value=""2"">cwbcoIPAddrLookup1Day</option>  " 
	end if 
	
	if defaultVal = 3 then
		S = S &  "<option value=""3"" selected>cwbcoIPAddrLookup1Week</option> " 
	else
		S = S &  "<option value=""3"">cwbcoIPAddrLookup1Week</option> " 
	end if 
	
	if defaultVal = 4 then
		S = S &  "<option value=""4"" selected>cwbcoIPAddrLookupNever</option> " 
	else
		S = S &  "<option value=""4"">cwbcoIPAddrLookupNever</option> " 
	end if 
	
	if defaultVal = 5 then
		S = S &  "<option value=""5"" selected>cwbcoIPAddrLookupAfterStartup</option> " 
	else
		S = S &  "<option value=""5"">cwbcoIPAddrLookupAfterStartup</option> " 
	end if 
	
	S = S &  " </select>IP address lookup  (recommended value is never). </td>"	
	
	GetIPControlText = S
End Function

'********************************************************************************
' Set the default value to the current value
'********************************************************************************
Function GetPortControlText (defaultVal)
Dim S 
	
	if defaultVal < 0 or defaultVal > 2 then
		GetPortControlText = "<td width=""100%""><font color=#ff0020><b>Unable to retrieve Port lookup mode. </b></font></td>"
		Exit function
	end if
	
	'"<td width=""100%""><select size=""1"" name=""PortLookup""> " & _
   ' "<option selected value=""0"">cwbcoPortLookupServer (default)</option>  " & _
   '"<option value=""1"">cwbcoPortLookupLocal</option> " & _
   '"<option value=""2"">cwbcoPortLookupStandard</option> " & _
   '"</select>Port lookup mode (recommended value Standard)</td>"
    
	S = "<td width=""100%""><select size=""1"" name=""PortLookup""> " 
	if defaultVal = 0 then
		S = S & "<option selected value=""0"">cwbcoPortLookupServer (default)</option>  "
	else 
		S = S & "<option value=""0"">cwbcoPortLookupServer (default)</option>  "
	end if 
	
	if defaultVal = 1 then
		S = S & "<option selected value=""1"">cwbcoPortLookupLocal</option> "
	else
		S = S & "<option value=""1"">cwbcoPortLookupLocal</option> " 
	end if 
	
	if defaultVal = 2 then
		S = S &   "<option selected value=""2"">cwbcoPortLookupStandard</option> " 
	else
		S = S &   "<option value=""2"">cwbcoPortLookupStandard</option> " 
	end if 
		
	S = S &   "</select>Port lookup mode (recommended value Standard)</td>"
	
	GetPortControlText = S
End Function

Function PrintSysKeyError( sysname )
	PrintSysKeyError =  "The registry hive for system name <font color=#ff0020><b>" & sysname & "</b></font> " & _
						" has not been created or the IIS user account may not be" & _
						" authorized to read that part of the registry.  To create the hive run the program cwbcfg using the options "  & _
						" ""/host (AS/400 ip address or name)"" ""/s"". <br> " 
End Function
%>



</BODY>
</HTML>